/**
 * @author ebonneau
 * @date 07/02/22
 * @version 1.0.0
 * @project SIEau
 * @table codes_sandre
 */

# --- !Ups

delete from codes_sandre where champ='USAGES';
insert into codes_sandre values ('USAGES',0,'USAGE INCONNU','Usage inconnu', null,null,null,null,null,'0');
insert into codes_sandre values ('USAGES',1,'PAS D''USAGE','L''absence d''usage peut etre déclarée par un gestionnaire quand il a la connaissance qu''aucune exploitation du point d''eau n''est réalisee.', null,null,null,null,null,'1');
insert into codes_sandre values ('USAGES',2,'IRRIGATION','Eau nécessaire aux cultures pour leur croissance, et/ou lutte antigel des cultures pérennes.', null,null,null,null,null,'2');
insert into codes_sandre values ('USAGES',8,'Irrigation par aspersion','Mode d''irrigation consistant e reproduire la pluie en aspergeant les cultures avec de l''eau mise sous pression.', null,null,null,null,null,'2A');
insert into codes_sandre values ('USAGES',9,'Irrigation gravitaire','Mode d''irrigation consistant à transporter l''eau jusqu''au bord et à l''intérieur des parcelles dans des systèmes aménagés suivant la pente naturelle.', null,null,null,null,null,'2B');
insert into codes_sandre values ('USAGES',10,'Irrigation au goutte à goutte','Mode d''irrigation consistant à acheminer l''eau sous faible pression jusqu’aux racines de chacune des plantes et à la distribuer au compte-goutte, en surface ou en souterrain, à l’aide de petits tuyaux, posés sur le sol ou enterrés.', null,null,null,null,null,'2C');
insert into codes_sandre values ('USAGES',11,'Irrigation par tout autre procédé','Irrigation par tout autre procédé', null,null,null,null,null,'2D');
insert into codes_sandre values ('USAGES',12,'Lutte antigel de cultures pérennes','Mode d''aspersion permettant de lutter contre le gel des cultures pérennes.', null,null,null,null,null,'2E');
insert into codes_sandre values ('USAGES',3,'AGRICULTURE-ELEVAGE (hors irrigation)','Tous les usages agricoles de l''eau, à l''exception de l''irrigation (abreuvage, élevage piscicole, nettoyage des bâtiments d''élevage, dilution des produits à épandre : engrais, phytosanitaires...)', null,null,null,null,null,'3');
insert into codes_sandre values ('USAGES',13,'Abreuvage','Eau destinée à l''abreuvage des animaux de tous les types d''élevage (bovins, porcins, ovins, volailles, autres).', null,null,null,null,null,'3A');
insert into codes_sandre values ('USAGES',14,'Aquaculture','Toute activité de production animale et végétale en milieu aquatique. Elles concernent notamment les productions de poissons (pisciculture), d''huitres (ostréiculture), de moules (mytiliculture), et d''autres coquillages (conchyliculture) ou encore d''algues ou autres. ', null,null,null,null,null,'3B');
insert into codes_sandre values ('USAGES',4,'INDUSTRIE','Usages industriels de l''eau non differentiables (agro-alimentaire, industrie hors agro-alimentaire, exhaures de mines,…).', null,null,null,null,null,'4');
insert into codes_sandre values ('USAGES',15,'Agro-alimentaire','Eau utilisée par l''industrie agro-alimentaire nécessitant une qualité identique à l''AEP (produits d''origine végétale ou animale, boissons alcoolisées et non alcoolisées).', null,null,null,null,null,'4A');
insert into codes_sandre values ('USAGES',16,'Industrie hors agro-alim','Eau utilisée par l''industrie dans le procédé de production (hors agro-alimentaire), le nettoyage.', null,null,null,null,null,'4B');
insert into codes_sandre values ('USAGES',17,'Exhaure','Eau évacuée des excavations souterraines telles que des mines, des carrières, des ouvrages de génie civil (exemples : parkings, lignes ferroviaires,..) pour en éviter l''ennoiement.', null,null,null,null,null,'4C');
insert into codes_sandre values ('USAGES',18,'Refroidissement conduisant à une restitution > 99%','Refroidissement industriel hors centrale de production d’énergie, conduisant à une restitution  > 99%', null,null,null,null,null,'4D');
insert into codes_sandre values ('USAGES',5,'AEP','Utilisation pour l''alimentation en eau potable (sans pouvoir faire la distinction entre alimentation collective ou individuelle).', null,null,null,null,null,'5');
insert into codes_sandre values ('USAGES',6,'Alimentation collective','Captage réservé à l''usage d''au moins deux familles ou de tout autre structure industrielle ou collective (commune, école, camping, colonie...).', null,null,null,null,null,'5A');
insert into codes_sandre values ('USAGES',7,'Alimentation individuelle','Captage réservé à l''usage d''une seule famille.', null,null,null,null,null,'5B');
insert into codes_sandre values ('USAGES',19,'ENERGIE','Utilisation des ressources énergétiques d''une ressource en eau', null,null,null,null,null,'6');
insert into codes_sandre values ('USAGES',20,'Pompe à chaleur','Utilisation des propriétés calorifiques de l''eau d''une ressource en eau (géothermie de très basse énergie : < 30°C) après élévation de la température au moyen d''une pompe à chaleur. Utilisation de la capacité d''une ressource en eau à absorber des calories (climatisation).', null,null,null,null,null,'6A');
insert into codes_sandre values ('USAGES',21,'Géothermie','Utilisation des propriétés calorifiques d''une ressource en eau: géothermie de haute énergie (>180°C) ou de basse énergie (entre 30 et 100°C).', null,null,null,null,null,'6B');
insert into codes_sandre values ('USAGES',22,'Refroidissement centrales de production d''énergie','Utilisation de l''eau d''une ressource pour le refroidissement de centrales thermiques ou nucléaires de production d''énergie.', null,null,null,null,null,'6C');
insert into codes_sandre values ('USAGES',23,'Refroidissement de centrales thermiques','Utilisation de l''eau d''une ressource pour le refroidissement de centrales thermiques en circuit fermé. ', null,null,null,null,null,'6C1');
insert into codes_sandre values ('USAGES',24,'Refroidissement de centrales nucléaires','Utilisation de l''eau d''une ressource pour le refroidissement de centrales nucléaires en circuit fermé. ', null,null,null,null,null,'6C2');
insert into codes_sandre values ('USAGES',25,'Refroidissement centrales de production électrique','Refroidissement des centrales de production électrique, conduisant à une restitution  >  99% (circuit ouvert)', null,null,null,null,null,'6C3');
insert into codes_sandre values ('USAGES',26,'Barrages hydro-électriques - force motrice','Utilisation de la force motrice de l''eau d''une ressource pour produire de l''électricité (barrage hydro-électrique)', null,null,null,null,null,'6D');
insert into codes_sandre values ('USAGES',27,'LOISIRS','Eau destinée à une utilisation ludique (parc d''attractions, lac artificiel aménagé pour le tourisme, station de ski, patinoire, canon à neige, pratiques de baignade, piscines, centres nautiques, golf, stade, centres hippiques…).', null,null,null,null,null,'7');
insert into codes_sandre values ('USAGES',28,'Bassin de natation','Bassin de nation a usage public ou privé.', null,null,null,null,null,'7a');
insert into codes_sandre values ('USAGES',29,'Baignade','Est définie comme eau de baignade toute partie des eaux de surface dans laquelle une commune s''attend à ce qu''un grand nombre de personnes se baignent et dans laquelle l''autorité compétente n''a pas interdit la baignade de façon permanente. Ne sont pas considérés comme eau de baignade : - les bassins de natation et de cure - les eaux captives qui sont soumises à un traitement ou sont utilisées à des fins thérapeutiques ', null,null,null,null,null,'7b');
insert into codes_sandre values ('USAGES',30,'Autres activités de loisir','', null,null,null,null,null,'7c');
insert into codes_sandre values ('USAGES',31,'Arrosage','Arrosage d''une surface destinée à une activité de loisir. Par exemple : stade, arrosages municipaux, golf,...', null,null,null,null,null,'7d');
insert into codes_sandre values ('USAGES',32,'Canon à neige','Eau destinée à la production de neige de culture.', null,null,null,null,null,'7e');
insert into codes_sandre values ('USAGES',33,'EMBOUTEILLAGE','Eau destinée à être mise en bouteille pour la consommation.', null,null,null,null,null,'8');
insert into codes_sandre values ('USAGES',34,'THERMALISME et THALASSOTHERAPIE','Le thermalisme recouvre l''ensemble des techniques et savoirs mis en œuvre pour utiliser les eaux minérales et leurs composants à des fins thérapeutiques ou de bien-être. Dans tous les cas, il s''agit d''eau douce, jamais d''eau de mer. Lorsqu''il s''agit d''eaux marines, on parle de Thalassothérapie.', null,null,null,null,null,'9');
insert into codes_sandre values ('USAGES',35,'Thermalisme','Ensemble des activités liées à l''exploitation et utilisation des eaux thermales et minérales. Elle inclut également les activités de balnéothérapie. ', null,null,null,null,null,'9a');
insert into codes_sandre values ('USAGES',36,'Thalassothérapie','C''est l''utilisation des bienfaits du milieu marin dans un but curatif ou préventif, sous surveillance médicale. Par milieu marin, on entend le climat, l''eau de mer, les boues marines, les algues etc.', null,null,null,null,null,'9b');
insert into codes_sandre values ('USAGES',37,'DEFENSE CONTRE INCENDIE','Utilisation directe ou indirecte (stockage) de l''eau dans la lutte contre les incendies.', null,null,null,null,null,'10');
insert into codes_sandre values ('USAGES',38,'DEPOLLUTION','Dépollution d''une ressource en eau par prélèvement de l''eau contaminée par une pollution, éventuellement par injection préalable d''eau avant repompage.', null,null,null,null,null,'11');
insert into codes_sandre values ('USAGES',39,'REALIMENTATION D''UNE RESSOURCE EN EAU','Prélèvement d''eau continu ou occasionnel, faisant suite à une activité anthropique, destiné à l''injection ou la réalimentation d''une quantité d''eau non négligeable, provenant d''une ressource en eau et à destination d''une autre ressource (aquifère, cours d''eau, lac,...) ou d''un système de dérivation  et de canalisation d''eau ', null,null,null,null,null,'12');
insert into codes_sandre values ('USAGES',40,'SOUTIEN D''ETIAGE','Une masse d''eau retenue peut contribuer au maintien d’un débit minimum d’eau pour la vie aquatique (débit réservé) mais aussi pour satisfaire les besoins d’alimentation en eau (alimentation en eau potable des agglomérations, irrigation, refroidissement des centrales nucléaires…), situés en aval d''un ouvrage. ', null,null,null,null,null,'12a');
insert into codes_sandre values ('USAGES',41,'COMPENSATION EVAPORATION','Réalimentation d''une ressource en eau dans le but de compenser le volume d''eau évaporé. ', null,null,null,null,null,'12b');
insert into codes_sandre values ('USAGES',42,'COMPENSATION IRRIGATION','Réalimentation d''une ressource en eau  dans le but de compenser le volume d''eau prélevé pour l''irrigation.  ', null,null,null,null,null,'12c');
insert into codes_sandre values ('USAGES',43,'COMPENSATION SALUBRITE','Réalimentation d''une ressource en eau  dans le but de maintenir le débit ou le niveau d''eau suffisant pour assurer le bon fonctionnement du milieu aquatique.', null,null,null,null,null,'12d');
insert into codes_sandre values ('USAGES',44,'REMPLISSAGE PLAN D''EAU','Alimentation d''un plan d''eau', null,null,null,null,null,'12e');
insert into codes_sandre values ('USAGES',45,'CANAUX','Volume d''eau derivée à partir d''une ressource vers le canal.  ', null,null,null,null,null,'13');
insert into codes_sandre values ('USAGES',46,'VOLUME TECHNIQUE','Volume technique nécessaire a la circulation de l''eau dans le canal. ', null,null,null,null,null,'13a');
insert into codes_sandre values ('USAGES',47,'ALIMENTATION AU SOUTIEN CANAL','Utilisation de l''eau pour l''alimentation au soutien de canal. ', null,null,null,null,null,'13b');
insert into codes_sandre values ('USAGES',48,'SOUTIEN D''ETIAGE','Une masse d''eau retenue peut contribuer au maintien d’un débit minimum d’eau pour la vie aquatique (débit réservé) mais aussi pour satisfaire les besoins d’alimentation en eau (alimentation en eau potable des agglomérations, irrigation, refroidissement des centrales nucléaires…), situés en aval d''un ouvrage. ', null,null,null,null,null,'14');
insert into codes_sandre values ('USAGES',49,'ENTRETIEN DE VOIRIES','Utilisation de l''eau pour l''entretien des voiries.', null,null,null,null,null,'15');
insert into codes_sandre values ('USAGES',50,'ALIMENTATION AU SOUTIEN CANAL','Utilisation de l''eau pour l''alimentation au soutien de canal.  ', null,null,null,null,null,'16');
insert into codes_sandre values ('USAGES',51,'USAGE DOMESTIQUE','Prélèvement inférieur à 1000m3/an', null,null,null,null,null,'17');
# --- !Downs
